module Iupick
  # This is the class object for the waypoints.
  class Waypoints

    # This method pulls the complete information for a single waypoint.
    def self.get_waypoint_information(waypoint_id)
      if waypoint_id
        url = Iupick.get_base_url() + 'waypoints/' + waypoint_id.to_s + '/'
        headers = Iupick.generate_headers(auth = 'public')

        response = Unirest.get url,
          headers: headers
        decoded_response = response.body
        return decoded_response
      else
        return {
          'error': 'No es posible obtener la informacion del punto ' + waypoint_id.to_s
        }
      end
    end

    # This method allows you to pull the basic information required to plot
    # the waypoints in a map
    def self.get_waypoints_lite()
      url = Iupick.get_base_url() + 'waypoints/lite/'
      headers = Iupick.generate_headers(auth = 'public')

      response = Unirest.get url,
        headers: headers

      decoded_response = response.body
      return decoded_response
    end

    # This method allows you to pull the full information for waypoints in a
    # certain postal code
    def self.get_postal_code_waypoints(postal_code)
      url = Iupick.get_base_url() + 'waypoints/postal-ids/' + postal_code.to_s + '/'
      headers = Iupick.generate_headers(auth='public')

      response = Unirest.get url,
        headers: headers

      decoded_response = response.body
      return decoded_response
    end

  end
end
